	name fixint21
	.8087
	.386p

.model flat

_DATA SEGMENT USE32 'data'

; declared in filefix.c
extrn _platdos_oldInt21 : fword
extrn _platdos_cntInt21 : dword
extrn _platdos_cntInt21_eax : dword
extrn _platdos_cntInt21_ebx : dword
extrn _platdos_cntInt21_ecx : dword
extrn _platdos_cntInt21_edx : dword

_DATA ENDS

.code

; WATCOM C/C++ specific.
extrn __GETDS : near

oldCall:
	pushfd
	call		fword ptr _platdos_oldInt21
	pop			ds

	; recover the carry flag.

	push		ebx
	mov			ebx, esp
	pushfd
	pop			dword ptr [ebx + 0Ch]
	pop			ebx

	iretd

public newInt21_

newInt21_:
	push		ds
	call      	__GETDS

	; Log this int21 call.
    push        edi
    mov         edi, _platdos_cntInt21
    and         edi, 0ffh
	inc			_platdos_cntInt21
    mov         _platdos_cntInt21_eax[edi*4], eax
    mov         _platdos_cntInt21_ebx[edi*4], ebx
    mov         _platdos_cntInt21_ecx[edi*4], ecx
    mov         _platdos_cntInt21_edx[edi*4], edx
    pop         edi

	cmp	   		ah, 039h					; Is this "MKDIR"?
	je			short simplelfnxlat

	cmp	   		ah, 03ah					; Is this "RMDIR"?
	je			short simplelfnxlat

	cmp	   		ah, 041h					; Is this "UNLINK"?
	je			short msdos_del

	cmp	   		ah, 047h					; Is this "Get CWD"?
	je			short simplelfnxlat

	cmp	   		ah, 03dh					; Is this "OPEN"?
	je			short msdos_open

	cmp	   		ah, 03ch					; Is this "CREAT"?
	jne			oldCall

	; "CREAT" - CREATE OR TRUNCATE FILE
	pushad
    mov         esi, 11h					; Create or truncate flag.
	mov			bl, 2						; Create with r/w access mode.
    jmp         msdos_lfn

	msdos_open:
	; "OPEN" - OPEN EXISTING FILE

	pushad
    mov         esi, 1h						; Open flag.
	mov			ebx, eax 					; Open with access mode passed in.

    msdos_lfn:

	xchg		esi, edx
	and			ebx, 07Fh
	mov			eax, 0716Ch					; MSDOS Long filename API

    lfn_join:

	pushfd
	call		fword ptr _platdos_oldInt21
	pushfd
	pop			ecx							; ECX = EFLAGS
	mov			ebx, esp

	mov			dword ptr [ebx + 28], eax	; returned handle
	mov			word ptr  [ebx + 44], cx	; flags for potential errors
	popad

	pop			ds
	iretd

	msdos_del:
	; LONG FILENAME - DELETE FILE

	pushad
	xor         ch, ch
	xor         esi, esi
	mov         eax, 07141h
	jmp         lfn_join

	simplelfnxlat:
	pushad
	mov         al, ah
	mov         ah, 071h
	jmp         lfn_join

_TEXT ENDS

end
